<?

$encoding = get_http_var("encoding");

switch ($encoding):
case ('win'):
	$EnCharSet="windows-1251"; break;
case ('dos'):
	$EnCharSet="cp866"; break;
case ('mac'):
	$EnCharSet="x-mac"; break;
case ('iso'):
	$EnCharSet="iso-8859-5"; break;
default:
	$EnCharSet="koi8-r";
endswitch;

function assign_urls(&$template)
{
	GLOBAL $CONFIG;
	$template->assign_vars(array(
		'URL_MAIN'		=> formurl(''),
		'URL_NEWS'		=> formurl('news'),
		'URL_HISTORY'	=> formurl('history'),
		'URL_GATE'		=> formurl('gate'),
		'URL_FECHO'		=> formurl('fecho'),
		'URL_NODELIST'	=> formurl('nodelist'),
		'URL_SOFT'		=> formurl('soft'),
		'URL_DOCS'		=> formurl('docs'),
		'URL_ECHOLIST'	=> formurl('echolist'),
		'URL_LINKS'		=> formurl('links'),
		'URL_PROJECT'	=> formurl('project'),
		'BASE_URL'		=> rtrim($CONFIG->GetVar('site_location'),"/")
	));
}

function assign_encs(&$template)
{
	$template->assign_vars(array(
		'URL_KOI' => formenc('koi'),
		'URL_WIN' => formenc('win'),
		'URL_DOS' => formenc('dos'),
		'URL_MAC' => formenc('mac'),
		'URL_ISO' => formenc('iso')
	));
}

function assign_user(&$user,&$template)
{
	if ($user->exists) {
		$template->assign_vars(array(
			'USER_NAME'	=> $user->Vars['name'],
			'URL_EXIT'	=> formlogout()
		));
	} else {
		$template->assign_vars(array(
			'URL_LOGIN'		=> formurl('login'),
			'URL_REGISTER'	=> formurl('register')
		));
	}
}

function get_http_var($key)
{
	GLOBAL $HTTP_GET_VARS;
	if (!isset($HTTP_GET_VARS) || empty($HTTP_GET_VARS)) {
		parse_query_string();
	}
	if (isset($HTTP_GET_VARS[$key])) {
		return $HTTP_GET_VARS[$key];
	} else {
		return '';
	}
}

function get_http_post_var($key)
{
	GLOBAL $HTTP_POST_VARS;
	if (!isset($HTTP_POST_VARS) || empty($HTTP_POST_VARS)) {
		parse_post_input();
	}
	if (isset($HTTP_POST_VARS[$key])) {
		return $HTTP_POST_VARS[$key];
	} else {
		return '';
	}
}

function parse_query_string()
{
	GLOBAL $HTTP_GET_VARS, $_SERVER;
	if (isset($_SERVER['QUERY_STRING'])) {
		$array_vars = split('&',$_SERVER['QUERY_STRING']);
		foreach($array_vars as $line) {
			$key = strtok($line,'=');
			$val = strtok('');
			$HTTP_GET_VARS[$key] = $val;
		}
	}
}

function parse_post_input()
{
	GLOBAL $HTTP_POST_VARS, $_ENV;
	if (isset($_ENV['CONTENT_LENGTH'])) {
		if ($f = fopen("php://stdin","r")) {
			$array_vars = split('&',fread($f,$_ENV['CONTENT_LENGTH']));
			foreach($array_vars as $line) {
				$key = strtok($line,'=');
				$val = strtok('');
				$HTTP_POST_VARS[$key] = $val;
			}
			fclose($f);
		}
	}
}

function convert_to_koi($str,$from)
{
	switch ($from):
		case ('win'):
			return (convert_cyr_string($str,'w','k'));
		case ('dos'):
			return (convert_cyr_string($str,'d','k'));
		case ('mac'):
			return (convert_cyr_string($str,'m','k'));
		case ('iso'):
			return (convert_cyr_string($str,'i','k'));
		default:
			return ($str);
	endswitch;
}

function convert_from_koi($str,$to)
{
	switch ($to):
		case ('win'):
			return (convert_cyr_string($str,'k','w'));
		case ('dos'):
			return (convert_cyr_string($str,'k','d'));
		case ('mac'):
			return (convert_cyr_string($str,'k','m'));
		case ('iso'):
			return (convert_cyr_string($str,'k','i'));
		default:
			return ($str);
	endswitch;
}

function create_url($content,&$params_array)
{
	GLOBAL $CONFIG;
	$locate = rtrim($CONFIG->GetVar('site_location'),"/");
	$result = '"';
	if ($locate !== '') {
		$result .= $locate.'/'; 
	} else {
		$result .= '/';
	}
	if ($CONFIG->GetVar('use_rewrite')) {
		if ($content !== '' && !is_null($content)) {
			$result .= $content.'/';
		}
	} else {
		if ($content !== '') { 
			$params_array['content'] = $content; 
		}
		$mainfile = $CONFIG->GetVar('main_site_file');
		if ($mainfile === '') $mainfile = 'index.php';
		$result .= $mainfile.'?';
	}
	$cnt = 0;
	foreach($params_array as $key=>$value) {
		$result.=($cnt?'&amp;':'').$key.'='.$value;
		$cnt++;
	}
	$result.='"';
	return $result;
}

function formurl($name_of_page = '',$extension = '')
{
	GLOBAL $Current_User, $HTTP_GET_VARS;
	$params = array();
	foreach(split('&',$extension) as $str) {
		$arr = split('=',$str,2);
		if (sizeof($arr) == 2) {
			$params[$arr[0]] = $arr[1];
		}
	}
	if ($Current_User->exists) { 
		$params['uid'] = $Current_User->Vars['uid']; 
	}
	if (isset($HTTP_GET_VARS['encoding'])) { 
		$params['encoding'] = $HTTP_GET_VARS['encoding']; 
	}
	return create_url($name_of_page,$params);
}

function formenc($to_enc)
{
	GLOBAL $HTTP_GET_VARS;
	$params = $HTTP_GET_VARS;
	$params['encoding'] = $to_enc;
	$content = $params['content'];
	unset($params['content']);
	return create_url($content,$params);
}

function formlogin($uid)
{
	GLOBAL $HTTP_GET_VARS;
	$params = $HTTP_GET_VARS;
	$params['uid'] = $uid;
	unset($params['content']);
	return create_url('',$params);
}

function formlogout()
{
	GLOBAL $HTTP_GET_VARS, $CONFIG;
	$params = $HTTP_GET_VARS;
	unset($params['uid']);
	$content = $params['content'];
	unset($params['content']);
	return create_url($content,$params);
}

?>
